/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Raw.xs. Do not edit this file, edit Raw.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Raw.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <zmq.h>
#include <libzmqraw/eventmap.h>
#include <libzmqraw/mutex.h>
#include <libzmqraw/timers.h>

#ifndef MUTABLE_GV
#define MUTABLE_GV(p) ((GV *)MUTABLE_PTR(p))
#endif

#define FEATURE_IPC      1
#define FEATURE_PGM      2
#define FEATURE_TIPC     3
#define FEATURE_NORM     4
#define FEATURE_CURVE    5
#define FEATURE_GSSAPI   6
#define FEATURE_DRAFT    7

#include "const-c-constant.inc"
#include "const-c-error.inc"
#include "const-c-message_options.inc"
#include "const-c-message_properties.inc"
#include "const-c-socket_options.inc"

typedef struct
{
	void *context;
	zmq_raw_mutex *mutex;
	zmq_raw_timers *timers;
	int reference_count;
} zmq_raw_context;

typedef struct
{
	int code;
	SV *message;
	const char *file;
	unsigned int line;
} zmq_raw_error;

typedef struct
{
	void *socket;
	void *context;
	int type;
} zmq_raw_socket;

typedef struct
{
	void *poller;
	zmq_raw_event_map *interested;
	zmq_raw_event_map *events;
	zmq_poller_event_t *poller_events;
	int allocated;
	int size;
} zmq_raw_poller;

typedef struct
{
	int dummy;
} zmq_raw_proxy;

typedef struct my_cxt_t
{
	zmq_raw_timers *timers;
	zmq_raw_mutex *context_mutex;
} my_cxt_t;

STATIC PerlIO *zmq_get_socket_io (SV *sv)
{
	if (SvROK (sv))
		sv = SvRV (sv);

	if (SvTYPE (sv) == SVt_PVGV)
	{
		if (isGV_with_GP (sv))
		{
			GV *gv = MUTABLE_GV (sv);
			IO *io = GvIO (gv);
			if (io)
				return IoIFP (io);
		}
	}

	return NULL;
}

#ifdef _WIN32
STATIC SOCKET zmq_get_native_socket (PerlIO *io)
{
	return _get_osfhandle (PerlIO_fileno (io));
}
#else
STATIC int zmq_get_native_socket (PerlIO *io)
{
	return PerlIO_fileno (io);
}
#endif

STATIC MGVTBL null_mg_vtbl =
{
	NULL, /* get */
	NULL, /* set */
	NULL, /* len */
	NULL, /* clear */
	NULL, /* free */
#if MGf_COPY
	NULL, /* copy */
#endif /* MGf_COPY */
#if MGf_DUP
	NULL, /* dup */
#endif /* MGf_DUP */
#if MGf_LOCAL
	NULL, /* local */
#endif /* MGf_LOCAL */
};


#ifdef USE_ITHREADS
static int zmq_raw_ctx_dup (pTHX_ MAGIC *magic, CLONE_PARAMS *param)
{
	zmq_raw_context *context = (zmq_raw_context *)magic->mg_ptr;
	zmq_raw_mutex_lock (context->mutex);
	++context->reference_count;
	zmq_raw_mutex_unlock (context->mutex);
	return 0;
}
#endif

STATIC void xs_object_magic_attach_struct_with_table (pTHX_ SV *sv, void *ptr, MGVTBL *table, int flags)
{
	MAGIC *magic = sv_magicext (sv, NULL, PERL_MAGIC_ext, table, (const char *)ptr, 0);
	magic->mg_flags |= flags;
}

STATIC void xs_object_magic_attach_struct(pTHX_ SV *sv, void *ptr)
{
	xs_object_magic_attach_struct_with_table (aTHX_ sv, ptr, &null_mg_vtbl, 0);
}


STATIC void *xs_object_magic_get_struct (pTHX_ SV *sv)
{
	MAGIC *mg = NULL;

	if (SvTYPE (sv) >= SVt_PVMG)
	{
		MAGIC *tmp;

		for (tmp = SvMAGIC(sv); tmp;
			tmp = tmp -> mg_moremagic) {
			if ((tmp -> mg_type == PERL_MAGIC_ext) &&
				(tmp -> mg_virtual == &null_mg_vtbl))
				mg = tmp;
		}
	}

	return (mg) ? mg -> mg_ptr : NULL;
}


#define ZMQ_SV_TO_MAGIC(SV) \
	xs_object_magic_get_struct(aTHX_ SvRV (SV))

#define ZMQ_NEW_OBJ(rv, package, sv)                   \
	STMT_START {                                       \
		(rv) = sv_setref_pv (newSV(0), package, sv);   \
	} STMT_END

#ifdef USE_ITHREADS
#define ZMQ_NEW_REFCOUNTED_OBJ(rv, package, sv, dup)               \
	ZMQ_NEW_OBJ (rv, package, sv);                                 \
	STMT_START {                                                   \
		STATIC MGVTBL __FILE__##__LINE__##_vtbl =                  \
		{                                                          \
			NULL, NULL, NULL, NULL, NULL,                          \
			NULL, dup, NULL                                        \
		};                                                         \
		xs_object_magic_attach_struct_with_table (aTHX_ SvRV (rv), \
			sv, &__FILE__##__LINE__##_vtbl, MGf_DUP);              \
	} STMT_END

#else
#define ZMQ_NEW_REFCOUNTED_OBJ(rv, package, sv, dup)               \
	ZMQ_NEW_OBJ (rv, package, sv);
#endif

#define ZMQ_NEW_OBJ_WITH_MAGIC(rv, package, sv, magic) \
	STMT_START {                                       \
		(rv) = sv_setref_pv (newSV(0), package, sv);   \
		xs_object_magic_attach_struct (aTHX_ SvRV (rv), \
			SvREFCNT_inc_NN (magic)); \
	} STMT_END


STATIC const COP* zmq_closest_cop(pTHX_ const COP *cop, const OP *o, const OP *curop, bool opnext)
{
	dVAR;

	if (!o || !curop || (
	opnext ? o->op_next == curop && o->op_type != OP_SCOPE : o == curop
	))
		return cop;

	if (o->op_flags & OPf_KIDS)
	{
		const OP *kid;

		for (kid = cUNOPo->op_first; kid; kid = OpSIBLING (kid))
		{
			const COP *new_cop;

			if (kid->op_type == OP_NULL && kid->op_targ == OP_NEXTSTATE)
				cop = (const COP *)kid;

			/* Keep searching, and return when we've found something. */
			new_cop = zmq_closest_cop (aTHX_ cop, kid, curop, opnext);
			if (new_cop)
				return new_cop;
		}
    }

    return NULL;
}

STATIC zmq_raw_error *create_error_obj (int code, SV *message)
{
	zmq_raw_error *e;
	const COP *cop;

	Newxz (e, 1, zmq_raw_error);
	e -> code = code;
	e -> message = message;

	cop = zmq_closest_cop (aTHX_ PL_curcop, OpSIBLING(PL_curcop), PL_op, FALSE);
	if (cop == NULL)
		cop = PL_curcop;

	if (CopLINE (cop))
	{
		e -> file = CopFILE (cop);
		e -> line = CopLINE (cop);
	} else
		e -> file = "unknown";

	return e;
}

STATIC zmq_raw_error *create_error_obj_fmt (int code, const char *prefix, const char *pat, va_list *list)
{
	zmq_raw_error *e;

	e = create_error_obj (code, newSVpv (prefix, 0));
	sv_vcatpvf(e -> message, pat, list);

	return e;
}

STATIC void __attribute__noreturn__ croak_error_obj (zmq_raw_error *e)
{
	SV *res = NULL;
	ZMQ_NEW_OBJ (res, "ZMQ::Raw::Error", e);
	SvREFCNT_inc (e -> message);
	croak_sv (res);
}

STATIC void croak_usage (const char *pat, ...)
{
	zmq_raw_error *e;
	va_list list;

	va_start (list, pat);
	e = create_error_obj_fmt (-1, "", pat, &list);
	va_end (list);

	croak_error_obj (e);
}

STATIC void *zmq_sv_to_ptr (const char *type, SV *sv, const char *file, int line)
{
	SV *full_type = sv_2mortal (newSVpvf ("ZMQ::Raw::%s", type));

	if (!(sv_isobject (sv) && sv_derived_from (sv, SvPV_nolen (full_type))))
	croak_usage ("Argument is not of type %s @ (%s:%d)\n",
		SvPV_nolen (full_type), file, line);

	return INT2PTR (void *, SvIV ((SV *) SvRV (sv)));
}

#define ZMQ_SV_TO_PTR(type, sv) \
	zmq_sv_to_ptr(#type, sv, __FILE__, __LINE__)

#define zmq_raw_check_error(error) \
    STMT_START {					                                              \
		if (error < 0)                                                            \
		{                                                                         \
			zmq_raw_error *e;                                                     \
                                                                                  \
			if (zmq_errno() == EINTR || zmq_errno() == EAGAIN)                    \
			{                                                                     \
				int ctx = GIMME_V;                                                \
				if (ctx == G_ARRAY)                                               \
				{                                                                 \
					XSRETURN_EMPTY;                                               \
				}                                                                 \
                                                                                  \
				XSRETURN_UNDEF;                                                   \
			}                                                                     \
                                                                                  \
			e = create_error_obj (zmq_errno(), NULL);                             \
			if (SvTRUE(ERRSV))                                                    \
				e->message = newSVpv (SvPVbyte_nolen (ERRSV), 0);                 \
			else                                                                  \
				e->message = newSVpvf ("%s (errno: %d) @ (%s:%d)\n",              \
					zmq_strerror (zmq_errno()), zmq_errno(), __FILE__, __LINE__); \
                                                                                  \
			croak_error_obj (e);                                                  \
		}                                                                         \
    } STMT_END


#line 337 "Raw.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 481 "Raw.c"

/* INCLUDE:  Including 'const-xs-constant.inc' from 'Raw.xs' */


XS_EUPXS(XS_ZMQ__Raw__constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs-constant.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 506 "Raw.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs-constant.inc"
        /* Change this to _c_constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = _c_constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid ZMQ::Raw macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined ZMQ::Raw macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing ZMQ::Raw macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 584 "Raw.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'Raw.xs' from 'const-xs-constant.inc' */


XS_EUPXS(XS_ZMQ__Raw_has); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw_has)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, option");
    {
	SV *	package = ST(0)
;
	int	option = (int)SvIV(ST(1))
;
#line 337 "Raw.xs"
		const char *f = NULL;

#line 608 "Raw.c"
#line 340 "Raw.xs"
		switch (option)
		{
			case FEATURE_IPC:
				f = "ipc";
				break;
			case FEATURE_PGM:
				f = "pgm";
				break;
			case FEATURE_TIPC:
				f = "tipc";
				break;
			case FEATURE_NORM:
				f = "norm";
				break;
			case FEATURE_CURVE:
				f = "curve";
				break;
			case FEATURE_GSSAPI:
				f = "gssapi";
				break;
			case FEATURE_DRAFT:
				f = "draft";
				break;
			default:
				croak_usage ("unknown option %d", option);
		}

		if (zmq_has (f))
			XSRETURN_YES;

		XSRETURN_NO;
#line 641 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE:  Including 'xs/Context.xs' from 'Raw.xs' */


/* INCLUDE:  Including 'xs/Curve.xs' from 'xs/Context.xs' */


/* INCLUDE:  Including 'xs/Error.xs' from 'xs/Curve.xs' */


/* INCLUDE:  Including 'xs/Message.xs' from 'xs/Error.xs' */


/* INCLUDE:  Including 'xs/Poller.xs' from 'xs/Message.xs' */


/* INCLUDE:  Including 'xs/Proxy.xs' from 'xs/Poller.xs' */


/* INCLUDE:  Including 'xs/Socket.xs' from 'xs/Proxy.xs' */


/* INCLUDE:  Including 'xs/Timer.xs' from 'xs/Socket.xs' */


/* INCLUDE:  Including 'xs/Z85.xs' from 'xs/Timer.xs' */


XS_EUPXS(XS_ZMQ__Raw__Z85_encode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Z85_encode)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, decoded");
    {
	SV *	class = ST(0)
;
	SV *	decoded = ST(1)
;
#line 9 "./xs/Z85.xs"
		SV *encoded;

#line 688 "Raw.c"
	SV *	RETVAL;
#line 12 "./xs/Z85.xs"
		if (SvCUR (decoded)%4)
			croak_usage ("decoded length must be divisible by 4");

		encoded = sv_2mortal (newSV ((SvCUR (decoded)*4)/3+1));
		SvPOK_on (encoded);
		SvCUR_set (encoded, (SvCUR (decoded)*4)/3);

		if (zmq_z85_encode (SvPVX (encoded), (const uint8_t *)SvPVX (decoded), SvCUR (decoded)) == NULL)
			croak_usage ("encode failed");

		SvREFCNT_inc (encoded);
		RETVAL = encoded;

#line 704 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Z85_decode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Z85_decode)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, encoded");
    {
	SV *	class = ST(0)
;
	SV *	encoded = ST(1)
;
#line 33 "./xs/Z85.xs"
		SV *decoded;

#line 726 "Raw.c"
	SV *	RETVAL;
#line 36 "./xs/Z85.xs"
		if (SvCUR (encoded)%5)
			croak_usage ("encoded length must be divisible by 5");

		decoded = sv_2mortal (newSV ((SvCUR (encoded)*4)/5+1));
		SvPOK_on (decoded);
		SvCUR_set (decoded, (SvCUR (encoded)*4)/5);

		if (zmq_z85_decode ((uint8_t *)SvPVX (decoded), SvPVX (encoded)) == NULL)
			croak_usage ("decode failed");

		SvREFCNT_inc (decoded);
		RETVAL = decoded;

#line 742 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'xs/Timer.xs' from 'xs/Z85.xs' */


XS_EUPXS(XS_ZMQ__Raw__Timer__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Timer__new)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "class, context, after, interval");
    {
	SV *	class = ST(0)
;
	SV *	context = ST(1)
;
	int	after = (int)SvIV(ST(2))
;
	SV *	interval = ST(3)
;
#line 11 "./xs/Timer.xs"
		zmq_raw_timer *timer;
		zmq_raw_context *ctx;
		zmq_raw_socket *sock;
		SV *sv;

#line 774 "Raw.c"
	SV *	RETVAL;
#line 17 "./xs/Timer.xs"
		ctx = ZMQ_SV_TO_PTR (Context, context);

		zmq_raw_mutex_lock (ctx->mutex);
		if (ctx->timers == NULL)
		{
			ctx->timers = zmq_raw_timers_create();
			if (ctx->timers == NULL)
			{
				zmq_raw_mutex_unlock (ctx->mutex);
				zmq_raw_check_error (-1);
			}
		}
		zmq_raw_mutex_unlock (ctx->mutex);

		timer = zmq_raw_timers_start (ctx->timers, ctx->context,
			after, SvIOK (interval) ? SvIV (interval) : 0);
		if (timer == NULL)
			zmq_raw_check_error (-1);

		Newxz (sock, 1, zmq_raw_socket);
		sock->socket = zmq_raw_timer_get_recv (timer);

		ZMQ_NEW_OBJ_WITH_MAGIC (sv, "ZMQ::Raw::Socket", sock,
			SvRV (context));
		zmq_raw_timer_set_sv (timer, sv);

		ZMQ_NEW_OBJ_WITH_MAGIC (RETVAL, SvPVbyte_nolen (class), timer,
			SvRV (context));

#line 806 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Timer_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Timer_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 53 "./xs/Timer.xs"
		zmq_raw_timer *timer;

#line 826 "Raw.c"
#line 56 "./xs/Timer.xs"
		timer = ZMQ_SV_TO_PTR (Timer, self);
		XSRETURN_IV (zmq_raw_timer_id (timer));
#line 830 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Timer_running); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Timer_running)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
#line 64 "./xs/Timer.xs"
		zmq_raw_timer *timer;

#line 850 "Raw.c"
	SV *	RETVAL;
#line 67 "./xs/Timer.xs"
		timer = ZMQ_SV_TO_PTR (Timer, self);
		if (zmq_raw_timer_is_running (timer))
			XSRETURN_YES;

		XSRETURN_NO;
#line 858 "Raw.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_ZMQ__Raw__Timer_interval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Timer_interval)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
#line 78 "./xs/Timer.xs"
		int interval;
		zmq_raw_timer *timer;

#line 878 "Raw.c"
	int	RETVAL;
	dXSTARG;
#line 82 "./xs/Timer.xs"
		timer = ZMQ_SV_TO_PTR (Timer, self);

		if (items > 1)
		{
			if (!SvIOK (ST (1)) || SvIV (ST (1)) <= 0)
				croak_usage ("interval should be greater than zero");

			interval = SvIV (ST (1));
			zmq_raw_timer_set_interval (timer, interval);
		}

		RETVAL = zmq_raw_timer_get_interval (timer);

#line 895 "Raw.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Timer__cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Timer__cancel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 102 "./xs/Timer.xs"
		zmq_raw_timer *timer;

#line 914 "Raw.c"
#line 105 "./xs/Timer.xs"
		timer = ZMQ_SV_TO_PTR (Timer, self);

		zmq_raw_timers_stop (timer);
#line 919 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Timer_expire); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Timer_expire)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 114 "./xs/Timer.xs"
		zmq_raw_timer *timer;

#line 937 "Raw.c"
#line 117 "./xs/Timer.xs"
		timer = ZMQ_SV_TO_PTR (Timer, self);

		zmq_raw_timers_expire (timer);
#line 942 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Timer__reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Timer__reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 126 "./xs/Timer.xs"
		zmq_raw_timer *timer;

#line 960 "Raw.c"
#line 129 "./xs/Timer.xs"
		timer = ZMQ_SV_TO_PTR (Timer, self);

		zmq_raw_timers_reset (timer);
#line 965 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Timer_socket); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Timer_socket)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 138 "./xs/Timer.xs"
		zmq_raw_timer *timer;
		SV *recv;

#line 984 "Raw.c"
	SV *	RETVAL;
#line 142 "./xs/Timer.xs"
		timer = ZMQ_SV_TO_PTR (Timer, self);
		recv = MUTABLE_SV (zmq_raw_timer_get_sv (timer));

		SvREFCNT_inc (recv);
		RETVAL = recv;

#line 993 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Timer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Timer_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 155 "./xs/Timer.xs"
		zmq_raw_timer *timer;
		SV *recv;

#line 1014 "Raw.c"
#line 159 "./xs/Timer.xs"
		timer = ZMQ_SV_TO_PTR (Timer, self);
		recv = MUTABLE_SV (zmq_raw_timer_get_sv (timer));

		zmq_raw_timers_remove (timer);

		SvREFCNT_dec (recv);
		SvREFCNT_dec (ZMQ_SV_TO_MAGIC (self));
#line 1023 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Socket.xs' from 'xs/Timer.xs' */


/* INCLUDE:  Including 'const-xs-socket_options.inc' from 'xs/Socket.xs' */


XS_EUPXS(XS_ZMQ__Raw__Socket__constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket__constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs-socket_options.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 1055 "Raw.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs-socket_options.inc"
        /* Change this to _socket_option(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = _socket_option(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid ZMQ::Raw::Socket macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined ZMQ::Raw::Socket macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing ZMQ::Raw::Socket macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 1133 "Raw.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'xs/Socket.xs' from 'const-xs-socket_options.inc' */


XS_EUPXS(XS_ZMQ__Raw__Socket_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, context, type");
    {
	SV *	class = ST(0)
;
	SV *	context = ST(1)
;
	int	type = (int)SvIV(ST(2))
;
#line 12 "./xs/Socket.xs"
		zmq_raw_socket *sock;
		zmq_raw_context *ctx;

#line 1160 "Raw.c"
	SV *	RETVAL;
#line 16 "./xs/Socket.xs"
		ctx = ZMQ_SV_TO_PTR (Context, context);
		Newxz (sock, 1, zmq_raw_socket);
		sock->type = type;
		sock->socket = zmq_socket (ctx->context, type);
		sock->context = ctx->context;
		if (sock->socket == NULL)
		{
			Safefree (sock);
			zmq_raw_check_error (-1);
		}

		ZMQ_NEW_OBJ_WITH_MAGIC (RETVAL, SvPVbyte_nolen (class), sock,
			SvRV (context));

#line 1177 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Socket_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_bind)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, endpoint");
    {
	SV *	self = ST(0)
;
	const char *	endpoint = (const char *)SvPV_nolen(ST(1))
;
#line 38 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1200 "Raw.c"
#line 42 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);
		rc = zmq_bind (sock->socket, endpoint);
		zmq_raw_check_error (rc);
#line 1205 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Socket_unbind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_unbind)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, endpoint");
    {
	SV *	self = ST(0)
;
	const char *	endpoint = (const char *)SvPV_nolen(ST(1))
;
#line 52 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1226 "Raw.c"
#line 56 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);
		rc = zmq_unbind (sock->socket, endpoint);
		zmq_raw_check_error (rc);
#line 1231 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Socket_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_connect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, endpoint");
    {
	SV *	self = ST(0)
;
	const char *	endpoint = (const char *)SvPV_nolen(ST(1))
;
#line 66 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1252 "Raw.c"
#line 70 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);
		rc = zmq_connect (sock->socket, endpoint);
		zmq_raw_check_error (rc);
#line 1257 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Socket_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_disconnect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, endpoint");
    {
	SV *	self = ST(0)
;
	const char *	endpoint = (const char *)SvPV_nolen(ST(1))
;
#line 80 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1278 "Raw.c"
#line 84 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);
		rc = zmq_disconnect (sock->socket, endpoint);
		zmq_raw_check_error (rc);
#line 1283 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Socket_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_send)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, buffer, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	SV *	buffer = ST(1)
;
	int	flags;
#line 95 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1307 "Raw.c"

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 99 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);
		rc = zmq_send (sock->socket,
			SvPVX (buffer), SvCUR (buffer), flags);
		zmq_raw_check_error (rc);
		XSRETURN_YES;
#line 1321 "Raw.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_ZMQ__Raw__Socket_sendmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_sendmsg)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
#line 110 "./xs/Socket.xs"
		int rc, i;
		int flags = 0, count = 0;
		zmq_raw_socket *sock;

#line 1344 "Raw.c"
#line 115 "./xs/Socket.xs"
		if (items < 2)
			croak_usage ("not enough parameters provided");
		count = items-1;

		if (!sv_isobject (ST (items-1)) && SvIOK (ST (items-1)))
		{
			/* the last parameter looks like 'flags'. if all the preceding
			 * parameters are not ZMQ::Raw::Message objects, it is not
			 * 'flags'
			 */
			int is_flags = items-2 ? 1 : 0;
			for (i = 0; i < items-2; ++i && is_flags)
			{
				SV *item = ST (i+1);
				if (sv_isobject (item) && sv_derived_from (item, "ZMQ::Raw::Message"))
					continue;

				is_flags = 0;
			}

			if (is_flags)
			{
				flags = (int)SvIV (ST (items-1));
				--count;
			}
		}

		sock = ZMQ_SV_TO_PTR (Socket, self);
		for (i = 0; i < items && count; ++i)
		{
			zmq_msg_t msg;
			int extra = 0;
			SV *item = ST (i+1);

			if (--count > 0)
				extra = ZMQ_SNDMORE;

			if (sv_isobject (item) && sv_derived_from (item, "ZMQ::Raw::Message"))
			{
				rc = zmq_msg_init (&msg);
				zmq_raw_check_error (rc);

				rc = zmq_msg_copy (&msg, ZMQ_SV_TO_PTR (Message, item));
				if (rc < 0)
					zmq_msg_close (&msg);
				zmq_raw_check_error (rc);

	SENDMSG:
				rc = zmq_sendmsg (sock->socket, &msg, flags | extra);
				if (rc < 0)
					zmq_msg_close (&msg);
				zmq_raw_check_error (rc);

				rc = zmq_msg_close (&msg);
				zmq_raw_check_error (rc);
			}
			else
			{
				STRLEN size;
				const char *b = SvPV (item, size);

				rc = zmq_msg_init_size (&msg, size);
				zmq_raw_check_error (rc);

				Copy (b, zmq_msg_data (&msg), size, char);
				goto SENDMSG;
			}
		}

		XSRETURN_YES;
#line 1416 "Raw.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_ZMQ__Raw__Socket_recv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_recv)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	int	flags;
#line 192 "./xs/Socket.xs"
		int rc, ctx;
		int count = 0, more = 1;
		zmq_msg_t msg;
		zmq_raw_socket *sock;

#line 1441 "Raw.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 198 "./xs/Socket.xs"
		ctx = GIMME_V;

		sock = ZMQ_SV_TO_PTR (Socket, self);

		rc = zmq_msg_init (&msg);
		zmq_raw_check_error (rc);

		SV *buffer = sv_2mortal (newSV (16));
		SvPOK_on (buffer);
		SvCUR_set (buffer, 0);

		do
		{
			rc = zmq_recvmsg (sock->socket, &msg,
				flags);

			if (rc < 0)
				zmq_msg_close (&msg);
			zmq_raw_check_error (rc);

			sv_catpvn (buffer, zmq_msg_data (&msg), zmq_msg_size (&msg));

			more = zmq_msg_get (&msg, ZMQ_MORE);

			if (ctx == G_ARRAY)
			{
				++count;
				XPUSHs (buffer);
				buffer = NULL;

				if (more)
				{
					buffer = sv_2mortal (newSV (16));
					SvPOK_on (buffer);
					SvCUR_set (buffer, 0);
				}
			}
		}
		while (more);

		rc = zmq_msg_close (&msg);
		zmq_raw_check_error (rc);

		if (buffer)
		{
			++count;
			XPUSHs (buffer);
		}

		XSRETURN (count);
#line 1500 "Raw.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_ZMQ__Raw__Socket_recvmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_recvmsg)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	int	flags;
#line 255 "./xs/Socket.xs"
		int rc, ctx;
		int count = 0, more = 1;
		zmq_msg_t msg;
		zmq_raw_socket *sock;

#line 1525 "Raw.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 261 "./xs/Socket.xs"
		ctx = GIMME_V;

		sock = ZMQ_SV_TO_PTR (Socket, self);

		rc = zmq_msg_init (&msg);
		zmq_raw_check_error (rc);

		while (more)
		{
			rc = zmq_recvmsg (sock->socket, &msg, flags);
			if (rc < 0)
				zmq_msg_close (&msg);

			zmq_raw_check_error (rc);
			++count;

			{
				zmq_msg_t *obj;
				Newxz (obj, 1, zmq_msg_t);
				rc = zmq_msg_init (obj);
				zmq_raw_check_error (rc);

				rc = zmq_msg_copy (obj, &msg);
				zmq_raw_check_error (rc);

				SV *m;
				ZMQ_NEW_OBJ (m, "ZMQ::Raw::Message", obj);
				mXPUSHs (m);
			}

			more = zmq_msg_get (&msg, ZMQ_MORE);

			if (ctx != G_ARRAY)
				more = 0;
		}

		rc = zmq_msg_close (&msg);
		zmq_raw_check_error (rc);

		XSRETURN (count);
#line 1574 "Raw.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_ZMQ__Raw__Socket_setsockopt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_setsockopt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, option, value");
    {
	SV *	self = ST(0)
;
	int	option = (int)SvIV(ST(1))
;
	SV *	value = ST(2)
;
#line 309 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1598 "Raw.c"
#line 313 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);

		switch (option)
		{
			// int
			case ZMQ_BACKLOG:
			case ZMQ_CONFLATE:
			case ZMQ_CONNECT_TIMEOUT:
			case ZMQ_HANDSHAKE_IVL:
			case ZMQ_HEARTBEAT_IVL:
			case ZMQ_HEARTBEAT_TIMEOUT:
			case ZMQ_HEARTBEAT_TTL:
			case ZMQ_IMMEDIATE:
			case ZMQ_INVERT_MATCHING:
			case ZMQ_IPV6:
			case ZMQ_LINGER:
			case ZMQ_MULTICAST_HOPS:
			case ZMQ_MULTICAST_MAXTPDU:
			case ZMQ_PLAIN_SERVER:
			case ZMQ_USE_FD:
			case ZMQ_PROBE_ROUTER:
			case ZMQ_RATE:
			case ZMQ_RCVBUF:
			case ZMQ_RCVHWM:
			case ZMQ_RCVTIMEO:
			case ZMQ_RECONNECT_IVL:
			case ZMQ_RECONNECT_IVL_MAX:
			case ZMQ_RECOVERY_IVL:
			case ZMQ_REQ_CORRELATE:
			case ZMQ_REQ_RELAXED:
			case ZMQ_ROUTER_HANDOVER:
			case ZMQ_ROUTER_MANDATORY:
			case ZMQ_ROUTER_RAW:
			case ZMQ_ROUTER_NOTIFY:
			case ZMQ_SNDBUF:
			case ZMQ_SNDHWM:
			case ZMQ_SNDTIMEO:
			case ZMQ_STREAM_NOTIFY:
			case ZMQ_TCP_KEEPALIVE:
			case ZMQ_TCP_KEEPALIVE_CNT:
			case ZMQ_TCP_KEEPALIVE_IDLE:
			case ZMQ_TCP_KEEPALIVE_INTVL:
			case ZMQ_TCP_MAXRT:
			case ZMQ_TOS:
			case ZMQ_XPUB_VERBOSE:
			case ZMQ_XPUB_VERBOSER:
			case ZMQ_XPUB_MANUAL:
			case ZMQ_XPUB_NODROP:
			case ZMQ_CURVE_SERVER:
				{
					int v;
					if (!SvIOK (value))
						croak_usage ("Value is not an int");

					v = (int)SvIV (value);
					rc = zmq_setsockopt (sock->socket, option,
						&v, sizeof (v));
					zmq_raw_check_error (rc);
				}
				break;

			// int64
			case ZMQ_MAXMSGSIZE:
				{
					int64_t v;
					if (!SvIOK (value))
						croak_usage ("Value is not an int");

					v = SvIV (value);
					rc = zmq_setsockopt (sock->socket, option,
						&v, sizeof (v));
					zmq_raw_check_error (rc);
				}
				break;

			// binary
			case ZMQ_CONNECT_RID:
			case ZMQ_ROUTING_ID:
			case ZMQ_PLAIN_PASSWORD:
			case ZMQ_PLAIN_USERNAME:
			case ZMQ_SOCKS_PROXY:
			case ZMQ_SUBSCRIBE:
			case ZMQ_UNSUBSCRIBE:
			case ZMQ_XPUB_WELCOME_MSG:
			case ZMQ_ZAP_DOMAIN:
			case ZMQ_TCP_ACCEPT_FILTER:
			case ZMQ_CURVE_SECRETKEY:
			case ZMQ_CURVE_PUBLICKEY:
			case ZMQ_CURVE_SERVERKEY:
				{
					STRLEN len;
					char *buf;

					if (!SvPOK (value))
						croak_usage ("Value is not a string");

					buf = SvPV (value, len);
					rc = zmq_setsockopt (sock->socket, option,
						buf, len);
					zmq_raw_check_error (rc);
				}
				break;

			default:
				croak_usage ("Unsupported option");
		}
#line 1706 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Socket_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 425 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1725 "Raw.c"
#line 429 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);

		if (sock->context == NULL)
			croak_usage ("close() cannot be called on this socket");

		rc = zmq_close (sock->socket);
		zmq_raw_check_error (rc);

		sock->socket = zmq_socket (sock->context, sock->type);
		if (sock->socket == NULL)
			zmq_raw_check_error (-1);
#line 1738 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Socket_monitor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_monitor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, endpoint, events");
    {
	SV *	self = ST(0)
;
	const char *	endpoint = (const char *)SvPV_nolen(ST(1))
;
	int	events = (int)SvIV(ST(2))
;
#line 448 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1761 "Raw.c"
#line 452 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);

		rc = zmq_socket_monitor (sock->socket, endpoint, events);
		zmq_raw_check_error (rc);
#line 1767 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Socket_join); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_join)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, group");
    {
	SV *	self = ST(0)
;
	const char *	group = (const char *)SvPV_nolen(ST(1))
;
#line 463 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1788 "Raw.c"
#line 467 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);

		rc = zmq_join (sock->socket, group);
		zmq_raw_check_error (rc);
#line 1794 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Socket_leave); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_leave)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, group");
    {
	SV *	self = ST(0)
;
	const char *	group = (const char *)SvPV_nolen(ST(1))
;
#line 478 "./xs/Socket.xs"
		int rc;
		zmq_raw_socket *sock;

#line 1815 "Raw.c"
#line 482 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);

		rc = zmq_leave (sock->socket, group);
		zmq_raw_check_error (rc);
#line 1821 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Socket_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Socket_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 492 "./xs/Socket.xs"
		zmq_raw_socket *sock;

#line 1839 "Raw.c"
#line 495 "./xs/Socket.xs"
		sock = ZMQ_SV_TO_PTR (Socket, self);
		if (sock->socket)
			zmq_close (sock->socket);
		Safefree (sock);
		SvREFCNT_dec (ZMQ_SV_TO_MAGIC (self));
#line 1846 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Proxy.xs' from 'xs/Socket.xs' */


XS_EUPXS(XS_ZMQ__Raw__Proxy_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Proxy_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0)
;
#line 8 "./xs/Proxy.xs"
		zmq_raw_proxy *proxy = NULL;

#line 1867 "Raw.c"
	SV *	RETVAL;
#line 11 "./xs/Proxy.xs"
		Newxz (proxy, 1, zmq_raw_proxy);
		ZMQ_NEW_OBJ (RETVAL, "ZMQ::Raw::Proxy", proxy);

#line 1873 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Proxy_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Proxy_start)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "self, frontend, backend, ...");
    {
	SV *	self = ST(0)
;
	SV *	frontend = ST(1)
;
	SV *	backend = ST(2)
;
#line 23 "./xs/Proxy.xs"
		zmq_raw_socket *f, *b, *c = NULL, *s = NULL;

#line 1897 "Raw.c"
#line 26 "./xs/Proxy.xs"
		f = ZMQ_SV_TO_PTR (Socket, frontend);
		b = ZMQ_SV_TO_PTR (Socket, backend);
		if (SvOK (ST (3)))
			c = ZMQ_SV_TO_PTR (Socket, ST (3));
		if (SvOK (ST (4)))
			s = ZMQ_SV_TO_PTR (Socket, ST (4));
#ifdef USE_ITHREADS
		zmq_proxy_steerable (f->socket, b->socket,
			c ? c->socket : NULL,
			s ? s->socket : NULL);
#else
		croak_usage ("proxy requires interpreter threads");
#endif
#line 1912 "Raw.c"
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'xs/Poller.xs' from 'xs/Proxy.xs' */


XS_EUPXS(XS_ZMQ__Raw__Poller_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Poller_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0)
;
#line 8 "./xs/Poller.xs"
		zmq_raw_poller *poller = NULL;

#line 1933 "Raw.c"
	SV *	RETVAL;
#line 11 "./xs/Poller.xs"
		Newxz (poller, 1, zmq_raw_poller);
		poller->poller = zmq_poller_new();
		poller->events = zmq_raw_event_map_create();
		poller->interested = zmq_raw_event_map_create();
		if (poller->events == NULL || poller->interested == NULL || poller->poller == NULL)
		{
			zmq_raw_event_map_destroy (poller->events);
			zmq_raw_event_map_destroy (poller->interested);
			zmq_poller_destroy (&poller->poller);
			Safefree (poller);
			zmq_raw_check_error (-1);
		}

		ZMQ_NEW_OBJ (RETVAL, "ZMQ::Raw::Poller", poller);

#line 1951 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Poller_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Poller_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, socket, events");
    {
	SV *	self = ST(0)
;
	SV *	socket = ST(1)
;
	short	events = (short)SvIV(ST(2))
;
#line 35 "./xs/Poller.xs"
		zmq_raw_poller *poller;
		int rc;
		PerlIO *io;

#line 1977 "Raw.c"
#line 40 "./xs/Poller.xs"
		poller = ZMQ_SV_TO_PTR (Poller, self);

		io = zmq_get_socket_io (socket);
		if (io)
		{
			if (zmq_raw_event_map_get (poller->interested, SvRV (socket)))
				rc = zmq_poller_modify_fd (poller->poller, zmq_get_native_socket (io),
					events);
			else
				rc = zmq_poller_add_fd (poller->poller, zmq_get_native_socket (io),
					SvRV (socket), events);
			zmq_raw_check_error (rc);
		}
		else
		{
			zmq_raw_socket *sock = ZMQ_SV_TO_PTR (Socket, socket);

			if (zmq_raw_event_map_get (poller->interested, SvRV (socket)))
				rc = zmq_poller_modify (poller->poller, sock->socket,
					events);
			else
				rc = zmq_poller_add (poller->poller, sock->socket,
					SvRV (socket), events);
			zmq_raw_check_error (rc);
		}

		if (!zmq_raw_event_map_get (poller->interested, SvRV (socket)))
		{
			zmq_raw_event_map_add (poller->interested, SvRV (socket), events);
			SvREFCNT_inc (SvRV (socket));
			++poller->size;
		}

		if (poller->size > poller->allocated)
		{
			if (poller->poller_events)
				Safefree (poller->poller_events);

			Newxz (poller->poller_events, poller->size, zmq_poller_event_t);
			poller->allocated = poller->size;
		}
#line 2020 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Poller_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Poller_remove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, socket");
    {
	SV *	self = ST(0)
;
	SV *	socket = ST(1)
;
#line 89 "./xs/Poller.xs"
		zmq_raw_poller *poller;
		int rc;
		PerlIO *io;

#line 2042 "Raw.c"
#line 94 "./xs/Poller.xs"
		poller = ZMQ_SV_TO_PTR (Poller, self);

		io = zmq_get_socket_io (socket);
		if (io)
		{
			rc = zmq_poller_remove_fd (poller->poller, zmq_get_native_socket (io));
			if (rc != 0)
				XSRETURN_NO;
		}
		else
		{
			zmq_raw_socket *sock = ZMQ_SV_TO_PTR (Socket, socket);

			rc = zmq_poller_remove (poller->poller, sock->socket);
			if (rc != 0)
				XSRETURN_NO;
		}

		SvREFCNT_dec (SvRV (socket));
		--poller->size;

		zmq_raw_event_map_remove (poller->interested, SvRV (socket));

		XSRETURN_YES;
#line 2068 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Poller_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Poller_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 124 "./xs/Poller.xs"
		zmq_raw_poller *poller;
		SSize_t size;

#line 2087 "Raw.c"
	SV *	RETVAL;
#line 128 "./xs/Poller.xs"
		poller = ZMQ_SV_TO_PTR (Poller, self);
		RETVAL = newSViv ((IV)poller->size);

#line 2093 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Poller_wait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Poller_wait)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, timeout");
    {
	SV *	self = ST(0)
;
	long	timeout = (long)SvIV(ST(1))
;
#line 139 "./xs/Poller.xs"
		int i, count, rc;
		zmq_raw_poller *poller = NULL;
		SSize_t size;

#line 2117 "Raw.c"
#line 144 "./xs/Poller.xs"
		poller = ZMQ_SV_TO_PTR (Poller, self);

		zmq_raw_event_map_clear (poller->events);

		rc = zmq_poller_wait_all (poller->poller, poller->poller_events, poller->size, timeout);
		if (rc < 0)
		{
			if (zmq_errno() == EAGAIN)
				XSRETURN_IV (0);

			zmq_raw_check_error (rc);
		}

		count = 0;

		for (i = 0; i < poller->size && rc; ++i)
		{
			zmq_poller_event_t *e = poller->poller_events+i;

			if (e->events)
			{
				const short *events = zmq_raw_event_map_get (poller->interested, e->user_data);
				assert (events);

				if (e->events & *events)
				{
					zmq_raw_event_map_add (poller->events, e->user_data, e->events & *events);
					++count;
				}

				--rc;
			}
		}

		XSRETURN_IV (count);
#line 2154 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Poller_events); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Poller_events)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, socket");
    {
	SV *	self = ST(0)
;
	SV *	socket = ST(1)
;
#line 186 "./xs/Poller.xs"
		zmq_raw_poller *poller = NULL;
		const short *e;

#line 2175 "Raw.c"
#line 190 "./xs/Poller.xs"
		poller = ZMQ_SV_TO_PTR (Poller, self);

		if (!zmq_raw_event_map_get (poller->interested, SvRV (socket)))
			XSRETURN_UNDEF;

		e = zmq_raw_event_map_get (poller->events, SvRV (socket));
		if (e == NULL)
			XSRETURN_IV (0);

		XSRETURN_IV (*e);
#line 2187 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Poller_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Poller_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 206 "./xs/Poller.xs"
		zmq_raw_poller *poller;
		zmq_raw_event_map_iterator *iterator;

#line 2206 "Raw.c"
#line 210 "./xs/Poller.xs"
		poller = ZMQ_SV_TO_PTR (Poller, self);

		/* cleanup */
		iterator = zmq_raw_event_map_iterator_create (poller->interested);
		if (iterator)
		{
			do
			{
				SvREFCNT_dec (zmq_raw_event_map_iterator_key (iterator));
			}
			while (zmq_raw_event_map_iterator_next (iterator));

			zmq_raw_event_map_iterator_destroy (iterator);
		}

		zmq_raw_event_map_destroy (poller->interested);
		zmq_raw_event_map_destroy (poller->events);
		zmq_poller_destroy (&poller->poller);
		Safefree (poller);
#line 2227 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Message.xs' from 'xs/Poller.xs' */


/* INCLUDE:  Including 'const-xs-message_options.inc' from 'xs/Message.xs' */


/* INCLUDE:  Including 'const-xs-message_properties.inc' from 'const-xs-message_options.inc' */


XS_EUPXS(XS_ZMQ__Raw__Message__p_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message__p_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs-message_properties.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	/* IV		iv;	Uncomment this if you need to return IVs */
	/* NV		nv;	Uncomment this if you need to return NVs */
	const char	*pv = NULL; /* avoid uninit var warning */
#line 2262 "Raw.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs-message_properties.inc"
	type = _message_property(aTHX_ s, len, &pv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid ZMQ::Raw::Message macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined ZMQ::Raw::Message macro %s, used",
				   s));
          PUSHs(sv);
          break;
	/* Uncomment this if you need to return IVs
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break; */
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break;
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing ZMQ::Raw::Message macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 2338 "Raw.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'const-xs-message_options.inc' from 'const-xs-message_properties.inc' */


XS_EUPXS(XS_ZMQ__Raw__Message__o_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message__o_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs-message_options.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 2368 "Raw.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs-message_options.inc"
        /* Change this to _message_option(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = _message_option(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid ZMQ::Raw::Message macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined ZMQ::Raw::Message macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing ZMQ::Raw::Message macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 2446 "Raw.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'xs/Message.xs' from 'const-xs-message_options.inc' */


XS_EUPXS(XS_ZMQ__Raw__Message_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0)
;
#line 11 "./xs/Message.xs"
		int rc;
		zmq_msg_t *msg;

#line 2469 "Raw.c"
	SV *	RETVAL;
#line 15 "./xs/Message.xs"
		Newx (msg, 1, zmq_msg_t);

		rc = zmq_msg_init (msg);
		zmq_raw_check_error (rc);

		ZMQ_NEW_OBJ (RETVAL, SvPVbyte_nolen (class), msg);

#line 2479 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Message_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_data)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
#line 29 "./xs/Message.xs"
		int rc;
		zmq_msg_t *msg;

#line 2500 "Raw.c"
	SV *	RETVAL;
#line 33 "./xs/Message.xs"
		msg = ZMQ_SV_TO_PTR (Message, self);

		if (items > 1)
		{
			STRLEN len;
			char *buf = SvPV (ST (1), len);

			rc = zmq_msg_close (msg);
			zmq_raw_check_error (rc);

			rc = zmq_msg_init_size (msg, len);
			zmq_raw_check_error (rc);

			Copy (buf, zmq_msg_data (msg), len, char);
		}

		if (zmq_msg_size (msg) == 0)
			XSRETURN_UNDEF;

		RETVAL = newSVpv (zmq_msg_data (msg), zmq_msg_size (msg));

#line 2524 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Message_more); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_more)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 61 "./xs/Message.xs"
		RETVAL = zmq_msg_more (ZMQ_SV_TO_PTR (Message, self));

#line 2546 "Raw.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Message_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	unsigned int	RETVAL;
	dXSTARG;
#line 70 "./xs/Message.xs"
		RETVAL = (unsigned int)zmq_msg_size (ZMQ_SV_TO_PTR (Message, self));

#line 2567 "Raw.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Message_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 79 "./xs/Message.xs"
		int rc;
		zmq_msg_t *msg, *old;

#line 2587 "Raw.c"
	SV *	RETVAL;
#line 83 "./xs/Message.xs"
		old = ZMQ_SV_TO_PTR (Message, self);

		Newx (msg, 1, zmq_msg_t);
		rc = zmq_msg_init (msg);
		zmq_raw_check_error (rc);

		rc = zmq_msg_copy (msg, old);
		if (rc < 0)
			Safefree (msg);
		zmq_raw_check_error (rc);

		ZMQ_NEW_OBJ (RETVAL, "ZMQ::Raw::Message", msg);

#line 2603 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Message_routing_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_routing_id)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
#line 103 "./xs/Message.xs"
		int rc;
		uint32_t id;

#line 2624 "Raw.c"
	unsigned int	RETVAL;
	dXSTARG;
#line 107 "./xs/Message.xs"
		if (items > 1)
		{
			if (!SvIOK (ST (1)) || SvIV (ST (1)) < 0)
				croak_usage ("routing_id should be unsigned");

			id = SvIV (ST (1));
			rc = zmq_msg_set_routing_id (ZMQ_SV_TO_PTR (Message, self), id);
			zmq_raw_check_error (rc);
		}

		id = zmq_msg_routing_id (ZMQ_SV_TO_PTR (Message, self));
		if (id == 0)
			XSRETURN_UNDEF;

		RETVAL = id;

#line 2644 "Raw.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Message_group); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_group)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
#line 130 "./xs/Message.xs"
		int rc;
		const char *g;

#line 2664 "Raw.c"
	const char *	RETVAL;
	dXSTARG;
#line 134 "./xs/Message.xs"
		if (items > 1)
		{
			rc = zmq_msg_set_group (ZMQ_SV_TO_PTR (Message, self), SvPV_nolen (ST (1)));
			zmq_raw_check_error (rc);
		}

		g = zmq_msg_group (ZMQ_SV_TO_PTR (Message, self));
		if (g == NULL)
			XSRETURN_UNDEF;

		RETVAL = g;

#line 2680 "Raw.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Message_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, property");
    {
	SV *	self = ST(0)
;
	int	property = (int)SvIV(ST(1))
;
#line 154 "./xs/Message.xs"
		int rc;

#line 2701 "Raw.c"
	int	RETVAL;
	dXSTARG;
#line 157 "./xs/Message.xs"
		rc = zmq_msg_get (ZMQ_SV_TO_PTR (Message, self), property);
		zmq_raw_check_error (rc);
		RETVAL = rc;

#line 2709 "Raw.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Message_gets); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_gets)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, property");
    {
	SV *	self = ST(0)
;
	const char *	property = (const char *)SvPV_nolen(ST(1))
;
#line 169 "./xs/Message.xs"
		const char *value;

#line 2730 "Raw.c"
	const char *	RETVAL;
	dXSTARG;
#line 172 "./xs/Message.xs"
		value = zmq_msg_gets (ZMQ_SV_TO_PTR (Message, self), property);
		if (value == NULL)
			XSRETURN_UNDEF;

		RETVAL = value;

#line 2740 "Raw.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Message_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Message_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 185 "./xs/Message.xs"
		int rc;
		zmq_msg_t *msg;

#line 2760 "Raw.c"
#line 189 "./xs/Message.xs"
		msg = ZMQ_SV_TO_PTR (Message, self);

		rc = zmq_msg_close (msg);
		zmq_raw_check_error (rc);
		Safefree (msg);
#line 2767 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Error.xs' from 'xs/Message.xs' */


/* INCLUDE:  Including 'const-xs-error.inc' from 'xs/Error.xs' */


XS_EUPXS(XS_ZMQ__Raw__Error__constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Error__constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs-error.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 2799 "Raw.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs-error.inc"
        /* Change this to _error_constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = _error_constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid ZMQ::Raw::Error macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined ZMQ::Raw::Error macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing ZMQ::Raw::Error macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 2877 "Raw.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'xs/Error.xs' from 'const-xs-error.inc' */


XS_EUPXS(XS_ZMQ__Raw__Error_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Error_message)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 10 "./xs/Error.xs"
		zmq_raw_error *error;

#line 2899 "Raw.c"
	SV *	RETVAL;
#line 13 "./xs/Error.xs"
		error = ZMQ_SV_TO_PTR (Error, self);
		SvREFCNT_inc (error -> message);
		RETVAL = error -> message;

#line 2906 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Error_code); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Error_code)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 24 "./xs/Error.xs"
		zmq_raw_error *error;

#line 2926 "Raw.c"
	SV *	RETVAL;
#line 27 "./xs/Error.xs"
		error = ZMQ_SV_TO_PTR (Error, self);
		RETVAL = newSViv (error -> code);

#line 2932 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Error_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Error_file)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 37 "./xs/Error.xs"
		zmq_raw_error *error;

#line 2952 "Raw.c"
	SV *	RETVAL;
#line 40 "./xs/Error.xs"
		error = ZMQ_SV_TO_PTR (Error, self);
		RETVAL = newSVpv (error -> file, 0);

#line 2958 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Error_line); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Error_line)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 50 "./xs/Error.xs"
		zmq_raw_error *error;

#line 2978 "Raw.c"
	SV *	RETVAL;
#line 53 "./xs/Error.xs"
		error = ZMQ_SV_TO_PTR (Error, self);
		RETVAL = newSVuv (error -> line);

#line 2984 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Error_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Error_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 63 "./xs/Error.xs"
		zmq_raw_error *error;

#line 3004 "Raw.c"
#line 66 "./xs/Error.xs"
		error = ZMQ_SV_TO_PTR (Error, self);
		SvREFCNT_dec (error -> message);
		Safefree (error);
#line 3009 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Curve.xs' from 'xs/Error.xs' */


XS_EUPXS(XS_ZMQ__Raw__Curve_keypair); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Curve_keypair)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	class = ST(0)
;
#line 8 "./xs/Curve.xs"
		int rc, ctx;
		SV *public_key, *private_key;

#line 3033 "Raw.c"
#line 12 "./xs/Curve.xs"
		ctx = GIMME_V;

		if (ctx == G_VOID)
			XSRETURN_EMPTY;

		public_key = sv_2mortal (newSV (41));
		private_key = sv_2mortal (newSV (41));
		SvPOK_on (public_key);
		SvPOK_on (private_key);
		SvCUR_set (public_key, 40);
		SvCUR_set (private_key, 40);

		rc = zmq_curve_keypair (SvPVX (public_key), SvPVX (private_key));
		zmq_raw_check_error (rc);

		XPUSHs (private_key);
		if (ctx == G_ARRAY)
		{
			XPUSHs (public_key);
			XSRETURN (2);
		}

		XSRETURN (1);
#line 3058 "Raw.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_ZMQ__Raw__Curve_public); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Curve_public)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, private_key");
    {
	SV *	class = ST(0)
;
	SV *	private_key = ST(1)
;
#line 42 "./xs/Curve.xs"
		int rc;
		SV *public_key;

#line 3080 "Raw.c"
	SV *	RETVAL;
#line 46 "./xs/Curve.xs"
		if (SvCUR (private_key) != 40)
			croak_usage ("private_key should be 40 bytes");

		public_key = sv_2mortal (newSV (41));
		SvPOK_on (public_key);
		SvCUR_set (public_key, 40);

		rc = zmq_curve_public (SvPVX (public_key), SvPVX (private_key));
		zmq_raw_check_error (rc);

		SvREFCNT_inc (public_key);
		RETVAL = public_key;

#line 3096 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'xs/Context.xs' from 'xs/Curve.xs' */


XS_EUPXS(XS_ZMQ__Raw__Context_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Context_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0)
;
#line 8 "./xs/Context.xs"
		int i;
		zmq_raw_context *ctx = NULL;

#line 3120 "Raw.c"
	SV *	RETVAL;
#line 12 "./xs/Context.xs"
		Newxz (ctx, 1, zmq_raw_context);
		ctx->mutex = zmq_raw_mutex_create();
		ctx->context = zmq_ctx_new();
		ctx->reference_count = 1;
		ctx->timers = NULL;

		ZMQ_NEW_REFCOUNTED_OBJ (RETVAL, "ZMQ::Raw::Context",
			ctx, zmq_raw_ctx_dup);

#line 3132 "Raw.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__Raw__Context_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Context_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, option, value");
    {
	SV *	self = ST(0)
;
	int	option = (int)SvIV(ST(1))
;
	int	value = (int)SvIV(ST(2))
;
#line 30 "./xs/Context.xs"
		int rc;
		zmq_raw_context *ctx;

#line 3157 "Raw.c"
#line 34 "./xs/Context.xs"
		ctx = ZMQ_SV_TO_PTR (Context, self);
		rc = zmq_ctx_set (ctx->context, option, value);
		zmq_raw_check_error (rc);
#line 3162 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Context_shutdown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Context_shutdown)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 43 "./xs/Context.xs"
		int rc;
		zmq_raw_context *ctx;

#line 3181 "Raw.c"
#line 47 "./xs/Context.xs"
		ctx = ZMQ_SV_TO_PTR (Context, self);
		rc = zmq_ctx_shutdown (ctx->context);
		zmq_raw_check_error (rc);
#line 3186 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_ZMQ__Raw__Context_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__Raw__Context_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 56 "./xs/Context.xs"
		zmq_raw_context *ctx;

#line 3204 "Raw.c"
#line 59 "./xs/Context.xs"
		ctx = ZMQ_SV_TO_PTR (Context, self);

		zmq_raw_mutex_lock (ctx->mutex);
		if (--ctx->reference_count > 0)
		{
			zmq_raw_mutex_unlock (ctx->mutex);
			XSRETURN (0);
		}

		if (ctx->timers)
			zmq_raw_timers_destroy (ctx->timers);

		zmq_ctx_term (ctx->context);
		zmq_raw_mutex_unlock (ctx->mutex);
		zmq_raw_mutex_destroy (ctx->mutex);
		Safefree (ctx);
#line 3222 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'Raw.xs' from 'xs/Context.xs' */

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_ZMQ__Raw); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_ZMQ__Raw)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("ZMQ::Raw::_constant", XS_ZMQ__Raw__constant);
        newXS_deffile("ZMQ::Raw::has", XS_ZMQ__Raw_has);
        newXS_deffile("ZMQ::Raw::Z85::encode", XS_ZMQ__Raw__Z85_encode);
        newXS_deffile("ZMQ::Raw::Z85::decode", XS_ZMQ__Raw__Z85_decode);
        newXS_deffile("ZMQ::Raw::Timer::_new", XS_ZMQ__Raw__Timer__new);
        newXS_deffile("ZMQ::Raw::Timer::id", XS_ZMQ__Raw__Timer_id);
        newXS_deffile("ZMQ::Raw::Timer::running", XS_ZMQ__Raw__Timer_running);
        newXS_deffile("ZMQ::Raw::Timer::interval", XS_ZMQ__Raw__Timer_interval);
        newXS_deffile("ZMQ::Raw::Timer::_cancel", XS_ZMQ__Raw__Timer__cancel);
        newXS_deffile("ZMQ::Raw::Timer::expire", XS_ZMQ__Raw__Timer_expire);
        newXS_deffile("ZMQ::Raw::Timer::_reset", XS_ZMQ__Raw__Timer__reset);
        newXS_deffile("ZMQ::Raw::Timer::socket", XS_ZMQ__Raw__Timer_socket);
        newXS_deffile("ZMQ::Raw::Timer::DESTROY", XS_ZMQ__Raw__Timer_DESTROY);
        newXS_deffile("ZMQ::Raw::Socket::_constant", XS_ZMQ__Raw__Socket__constant);
        newXS_deffile("ZMQ::Raw::Socket::new", XS_ZMQ__Raw__Socket_new);
        newXS_deffile("ZMQ::Raw::Socket::bind", XS_ZMQ__Raw__Socket_bind);
        newXS_deffile("ZMQ::Raw::Socket::unbind", XS_ZMQ__Raw__Socket_unbind);
        newXS_deffile("ZMQ::Raw::Socket::connect", XS_ZMQ__Raw__Socket_connect);
        newXS_deffile("ZMQ::Raw::Socket::disconnect", XS_ZMQ__Raw__Socket_disconnect);
        newXS_deffile("ZMQ::Raw::Socket::send", XS_ZMQ__Raw__Socket_send);
        newXS_deffile("ZMQ::Raw::Socket::sendmsg", XS_ZMQ__Raw__Socket_sendmsg);
        newXS_deffile("ZMQ::Raw::Socket::recv", XS_ZMQ__Raw__Socket_recv);
        newXS_deffile("ZMQ::Raw::Socket::recvmsg", XS_ZMQ__Raw__Socket_recvmsg);
        newXS_deffile("ZMQ::Raw::Socket::setsockopt", XS_ZMQ__Raw__Socket_setsockopt);
        newXS_deffile("ZMQ::Raw::Socket::close", XS_ZMQ__Raw__Socket_close);
        newXS_deffile("ZMQ::Raw::Socket::monitor", XS_ZMQ__Raw__Socket_monitor);
        newXS_deffile("ZMQ::Raw::Socket::join", XS_ZMQ__Raw__Socket_join);
        newXS_deffile("ZMQ::Raw::Socket::leave", XS_ZMQ__Raw__Socket_leave);
        newXS_deffile("ZMQ::Raw::Socket::DESTROY", XS_ZMQ__Raw__Socket_DESTROY);
        newXS_deffile("ZMQ::Raw::Proxy::new", XS_ZMQ__Raw__Proxy_new);
        newXS_deffile("ZMQ::Raw::Proxy::start", XS_ZMQ__Raw__Proxy_start);
        newXS_deffile("ZMQ::Raw::Poller::new", XS_ZMQ__Raw__Poller_new);
        newXS_deffile("ZMQ::Raw::Poller::add", XS_ZMQ__Raw__Poller_add);
        newXS_deffile("ZMQ::Raw::Poller::remove", XS_ZMQ__Raw__Poller_remove);
        newXS_deffile("ZMQ::Raw::Poller::size", XS_ZMQ__Raw__Poller_size);
        newXS_deffile("ZMQ::Raw::Poller::wait", XS_ZMQ__Raw__Poller_wait);
        newXS_deffile("ZMQ::Raw::Poller::events", XS_ZMQ__Raw__Poller_events);
        newXS_deffile("ZMQ::Raw::Poller::DESTROY", XS_ZMQ__Raw__Poller_DESTROY);
        newXS_deffile("ZMQ::Raw::Message::_p_constant", XS_ZMQ__Raw__Message__p_constant);
        newXS_deffile("ZMQ::Raw::Message::_o_constant", XS_ZMQ__Raw__Message__o_constant);
        newXS_deffile("ZMQ::Raw::Message::new", XS_ZMQ__Raw__Message_new);
        newXS_deffile("ZMQ::Raw::Message::data", XS_ZMQ__Raw__Message_data);
        newXS_deffile("ZMQ::Raw::Message::more", XS_ZMQ__Raw__Message_more);
        newXS_deffile("ZMQ::Raw::Message::size", XS_ZMQ__Raw__Message_size);
        newXS_deffile("ZMQ::Raw::Message::clone", XS_ZMQ__Raw__Message_clone);
        newXS_deffile("ZMQ::Raw::Message::routing_id", XS_ZMQ__Raw__Message_routing_id);
        newXS_deffile("ZMQ::Raw::Message::group", XS_ZMQ__Raw__Message_group);
        newXS_deffile("ZMQ::Raw::Message::get", XS_ZMQ__Raw__Message_get);
        newXS_deffile("ZMQ::Raw::Message::gets", XS_ZMQ__Raw__Message_gets);
        newXS_deffile("ZMQ::Raw::Message::DESTROY", XS_ZMQ__Raw__Message_DESTROY);
        newXS_deffile("ZMQ::Raw::Error::_constant", XS_ZMQ__Raw__Error__constant);
        newXS_deffile("ZMQ::Raw::Error::message", XS_ZMQ__Raw__Error_message);
        newXS_deffile("ZMQ::Raw::Error::code", XS_ZMQ__Raw__Error_code);
        newXS_deffile("ZMQ::Raw::Error::file", XS_ZMQ__Raw__Error_file);
        newXS_deffile("ZMQ::Raw::Error::line", XS_ZMQ__Raw__Error_line);
        newXS_deffile("ZMQ::Raw::Error::DESTROY", XS_ZMQ__Raw__Error_DESTROY);
        newXS_deffile("ZMQ::Raw::Curve::keypair", XS_ZMQ__Raw__Curve_keypair);
        newXS_deffile("ZMQ::Raw::Curve::public", XS_ZMQ__Raw__Curve_public);
        newXS_deffile("ZMQ::Raw::Context::new", XS_ZMQ__Raw__Context_new);
        newXS_deffile("ZMQ::Raw::Context::set", XS_ZMQ__Raw__Context_set);
        newXS_deffile("ZMQ::Raw::Context::shutdown", XS_ZMQ__Raw__Context_shutdown);
        newXS_deffile("ZMQ::Raw::Context::DESTROY", XS_ZMQ__Raw__Context_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

