#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
_error_constant_8 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     EMSGSIZE EMTHREAD ENETDOWN ENOTCONN ENOTSOCK */
  /* Offset 6 gives the best switch position.  */
  switch (name[6]) {
  case 'A':
    if (memEQ(name, "EMTHREAD", 8)) {
    /*                     ^       */
#ifdef EMTHREAD
      *iv_return = EMTHREAD;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'C':
    if (memEQ(name, "ENOTSOCK", 8)) {
    /*                     ^       */
#ifdef ENOTSOCK
      *iv_return = ENOTSOCK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ENOTCONN", 8)) {
    /*                     ^       */
#ifdef ENOTCONN
      *iv_return = ENOTCONN;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'W':
    if (memEQ(name, "ENETDOWN", 8)) {
    /*                     ^       */
#ifdef ENETDOWN
      *iv_return = ENETDOWN;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'Z':
    if (memEQ(name, "EMSGSIZE", 8)) {
    /*                     ^       */
#ifdef EMSGSIZE
      *iv_return = EMSGSIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_error_constant_12 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     EAFNOSUPPORT ECONNABORTED ECONNREFUSED EHOSTUNREACH */
  /* Offset 7 gives the best switch position.  */
  switch (name[7]) {
  case 'F':
    if (memEQ(name, "ECONNREFUSED", 12)) {
    /*                      ^           */
#ifdef ECONNREFUSED
      *iv_return = ECONNREFUSED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ECONNABORTED", 12)) {
    /*                      ^           */
#ifdef ECONNABORTED
      *iv_return = ECONNABORTED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'P':
    if (memEQ(name, "EAFNOSUPPORT", 12)) {
    /*                      ^           */
#ifdef EAFNOSUPPORT
      *iv_return = EAFNOSUPPORT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "EHOSTUNREACH", 12)) {
    /*                      ^           */
#ifdef EHOSTUNREACH
      *iv_return = EHOSTUNREACH;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_error_constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(EADDRINUSE EADDRNOTAVAIL EAFNOSUPPORT ECONNABORTED ECONNREFUSED
	       ECONNRESET EFSM EHOSTUNREACH EINPROGRESS EMSGSIZE EMTHREAD
	       ENETDOWN ENETRESET ENETUNREACH ENOBUFS ENOCOMPATPROTO ENOTCONN
	       ENOTSOCK ENOTSUP EPROTONOSUPPORT ETERM ETIMEDOUT));

print constant_types(), "\n"; # macro defs
foreach (C_constant ("ZMQ::Raw::Error", '_error_constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("ZMQ::Raw::Error", $types);
__END__
   */

  switch (len) {
  case 4:
    if (memEQ(name, "EFSM", 4)) {
#ifdef EFSM
      *iv_return = EFSM;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 5:
    if (memEQ(name, "ETERM", 5)) {
#ifdef ETERM
      *iv_return = ETERM;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 7:
    /* Names all of length 7.  */
    /* ENOBUFS ENOTSUP */
    /* Offset 4 gives the best switch position.  */
    switch (name[4]) {
    case 'S':
      if (memEQ(name, "ENOTSUP", 7)) {
      /*                   ^        */
#ifdef ENOTSUP
        *iv_return = ENOTSUP;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'U':
      if (memEQ(name, "ENOBUFS", 7)) {
      /*                   ^        */
#ifdef ENOBUFS
        *iv_return = ENOBUFS;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 8:
    return _error_constant_8 (aTHX_ name, iv_return);
    break;
  case 9:
    /* Names all of length 9.  */
    /* ENETRESET ETIMEDOUT */
    /* Offset 5 gives the best switch position.  */
    switch (name[5]) {
    case 'D':
      if (memEQ(name, "ETIMEDOUT", 9)) {
      /*                    ^         */
#ifdef ETIMEDOUT
        *iv_return = ETIMEDOUT;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'E':
      if (memEQ(name, "ENETRESET", 9)) {
      /*                    ^         */
#ifdef ENETRESET
        *iv_return = ENETRESET;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 10:
    /* Names all of length 10.  */
    /* EADDRINUSE ECONNRESET */
    /* Offset 1 gives the best switch position.  */
    switch (name[1]) {
    case 'A':
      if (memEQ(name, "EADDRINUSE", 10)) {
      /*                ^               */
#ifdef EADDRINUSE
        *iv_return = EADDRINUSE;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'C':
      if (memEQ(name, "ECONNRESET", 10)) {
      /*                ^               */
#ifdef ECONNRESET
        *iv_return = ECONNRESET;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 11:
    /* Names all of length 11.  */
    /* EINPROGRESS ENETUNREACH */
    /* Offset 5 gives the best switch position.  */
    switch (name[5]) {
    case 'N':
      if (memEQ(name, "ENETUNREACH", 11)) {
      /*                    ^            */
#ifdef ENETUNREACH
        *iv_return = ENETUNREACH;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'O':
      if (memEQ(name, "EINPROGRESS", 11)) {
      /*                    ^            */
#ifdef EINPROGRESS
        *iv_return = EINPROGRESS;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 12:
    return _error_constant_12 (aTHX_ name, iv_return);
    break;
  case 13:
    if (memEQ(name, "EADDRNOTAVAIL", 13)) {
#ifdef EADDRNOTAVAIL
      *iv_return = EADDRNOTAVAIL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 14:
    if (memEQ(name, "ENOCOMPATPROTO", 14)) {
#ifdef ENOCOMPATPROTO
      *iv_return = ENOCOMPATPROTO;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 15:
    if (memEQ(name, "EPROTONOSUPPORT", 15)) {
#ifdef EPROTONOSUPPORT
      *iv_return = EPROTONOSUPPORT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

