#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
_socket_option_8 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_IPV6 ZMQ_RATE ZMQ_TYPE */
  /* Offset 6 gives the best switch position.  */
  switch (name[6]) {
  case 'P':
    if (memEQ(name, "ZMQ_TYPE", 8)) {
    /*                     ^       */
#ifdef ZMQ_TYPE
      *iv_return = ZMQ_TYPE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (memEQ(name, "ZMQ_RATE", 8)) {
    /*                     ^       */
#ifdef ZMQ_RATE
      *iv_return = ZMQ_RATE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'V':
    if (memEQ(name, "ZMQ_IPV6", 8)) {
    /*                     ^       */
#ifdef ZMQ_IPV6
      *iv_return = ZMQ_IPV6;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_10 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_BLOCKY ZMQ_EVENTS ZMQ_LINGER ZMQ_RCVBUF ZMQ_RCVHWM ZMQ_SNDBUF
     ZMQ_SNDHWM ZMQ_USE_FD */
  /* Offset 8 gives the best switch position.  */
  switch (name[8]) {
  case 'E':
    if (memEQ(name, "ZMQ_LINGER", 10)) {
    /*                       ^        */
#ifdef ZMQ_LINGER
      *iv_return = ZMQ_LINGER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'F':
    if (memEQ(name, "ZMQ_USE_FD", 10)) {
    /*                       ^        */
#ifdef ZMQ_USE_FD
      *iv_return = ZMQ_USE_FD;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'K':
    if (memEQ(name, "ZMQ_BLOCKY", 10)) {
    /*                       ^        */
#ifdef ZMQ_BLOCKY
      *iv_return = ZMQ_BLOCKY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (memEQ(name, "ZMQ_EVENTS", 10)) {
    /*                       ^        */
#ifdef ZMQ_EVENTS
      *iv_return = ZMQ_EVENTS;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'U':
    if (memEQ(name, "ZMQ_RCVBUF", 10)) {
    /*                       ^        */
#ifdef ZMQ_RCVBUF
      *iv_return = ZMQ_RCVBUF;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "ZMQ_SNDBUF", 10)) {
    /*                       ^        */
#ifdef ZMQ_SNDBUF
      *iv_return = ZMQ_SNDBUF;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'W':
    if (memEQ(name, "ZMQ_RCVHWM", 10)) {
    /*                       ^        */
#ifdef ZMQ_RCVHWM
      *iv_return = ZMQ_RCVHWM;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "ZMQ_SNDHWM", 10)) {
    /*                       ^        */
#ifdef ZMQ_SNDHWM
      *iv_return = ZMQ_SNDHWM;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_12 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_AFFINITY ZMQ_CONFLATE ZMQ_IDENTITY ZMQ_RCVTIMEO ZMQ_SNDTIMEO */
  /* Offset 5 gives the best switch position.  */
  switch (name[5]) {
  case 'C':
    if (memEQ(name, "ZMQ_RCVTIMEO", 12)) {
    /*                    ^             */
#ifdef ZMQ_RCVTIMEO
      *iv_return = ZMQ_RCVTIMEO;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'D':
    if (memEQ(name, "ZMQ_IDENTITY", 12)) {
    /*                    ^             */
#ifdef ZMQ_IDENTITY
      *iv_return = ZMQ_IDENTITY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'F':
    if (memEQ(name, "ZMQ_AFFINITY", 12)) {
    /*                    ^             */
#ifdef ZMQ_AFFINITY
      *iv_return = ZMQ_AFFINITY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ZMQ_SNDTIMEO", 12)) {
    /*                    ^             */
#ifdef ZMQ_SNDTIMEO
      *iv_return = ZMQ_SNDTIMEO;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ZMQ_CONFLATE", 12)) {
    /*                    ^             */
#ifdef ZMQ_CONFLATE
      *iv_return = ZMQ_CONFLATE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_13 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_IMMEDIATE ZMQ_MECHANISM ZMQ_SUBSCRIBE ZMQ_TCP_MAXRT */
  /* Offset 4 gives the best switch position.  */
  switch (name[4]) {
  case 'I':
    if (memEQ(name, "ZMQ_IMMEDIATE", 13)) {
    /*                   ^               */
#ifdef ZMQ_IMMEDIATE
      *iv_return = ZMQ_IMMEDIATE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'M':
    if (memEQ(name, "ZMQ_MECHANISM", 13)) {
    /*                   ^               */
#ifdef ZMQ_MECHANISM
      *iv_return = ZMQ_MECHANISM;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'S':
    if (memEQ(name, "ZMQ_SUBSCRIBE", 13)) {
    /*                   ^               */
#ifdef ZMQ_SUBSCRIBE
      *iv_return = ZMQ_SUBSCRIBE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (memEQ(name, "ZMQ_TCP_MAXRT", 13)) {
    /*                   ^               */
#ifdef ZMQ_TCP_MAXRT
      *iv_return = ZMQ_TCP_MAXRT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_14 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_MAXMSGSIZE ZMQ_ROUTER_RAW ZMQ_ROUTING_ID ZMQ_ZAP_DOMAIN */
  /* Offset 9 gives the best switch position.  */
  switch (name[9]) {
  case 'G':
    if (memEQ(name, "ZMQ_MAXMSGSIZE", 14)) {
    /*                        ^           */
#ifdef ZMQ_MAXMSGSIZE
      *iv_return = ZMQ_MAXMSGSIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ZMQ_ROUTING_ID", 14)) {
    /*                        ^           */
#ifdef ZMQ_ROUTING_ID
      *iv_return = ZMQ_ROUTING_ID;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ZMQ_ZAP_DOMAIN", 14)) {
    /*                        ^           */
#ifdef ZMQ_ZAP_DOMAIN
      *iv_return = ZMQ_ZAP_DOMAIN;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "ZMQ_ROUTER_RAW", 14)) {
    /*                        ^           */
#ifdef ZMQ_ROUTER_RAW
      *iv_return = ZMQ_ROUTER_RAW;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_15 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_CONNECT_RID ZMQ_REQ_RELAXED ZMQ_SOCKS_PROXY ZMQ_THREAD_SAFE
     ZMQ_UNSUBSCRIBE ZMQ_XPUB_MANUAL ZMQ_XPUB_NODROP */
  /* Offset 13 gives the best switch position.  */
  switch (name[13]) {
  case 'A':
    if (memEQ(name, "ZMQ_XPUB_MANUAL", 15)) {
    /*                            ^        */
#ifdef ZMQ_XPUB_MANUAL
      *iv_return = ZMQ_XPUB_MANUAL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'B':
    if (memEQ(name, "ZMQ_UNSUBSCRIBE", 15)) {
    /*                            ^        */
#ifdef ZMQ_UNSUBSCRIBE
      *iv_return = ZMQ_UNSUBSCRIBE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "ZMQ_REQ_RELAXED", 15)) {
    /*                            ^        */
#ifdef ZMQ_REQ_RELAXED
      *iv_return = ZMQ_REQ_RELAXED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'F':
    if (memEQ(name, "ZMQ_THREAD_SAFE", 15)) {
    /*                            ^        */
#ifdef ZMQ_THREAD_SAFE
      *iv_return = ZMQ_THREAD_SAFE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "ZMQ_CONNECT_RID", 15)) {
    /*                            ^        */
#ifdef ZMQ_CONNECT_RID
      *iv_return = ZMQ_CONNECT_RID;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ZMQ_XPUB_NODROP", 15)) {
    /*                            ^        */
#ifdef ZMQ_XPUB_NODROP
      *iv_return = ZMQ_XPUB_NODROP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'X':
    if (memEQ(name, "ZMQ_SOCKS_PROXY", 15)) {
    /*                            ^        */
#ifdef ZMQ_SOCKS_PROXY
      *iv_return = ZMQ_SOCKS_PROXY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_16 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_CURVE_SERVER ZMQ_PLAIN_SERVER ZMQ_PROBE_ROUTER ZMQ_RECOVERY_IVL
     ZMQ_XPUB_VERBOSE */
  /* Offset 5 gives the best switch position.  */
  switch (name[5]) {
  case 'E':
    if (memEQ(name, "ZMQ_RECOVERY_IVL", 16)) {
    /*                    ^                 */
#ifdef ZMQ_RECOVERY_IVL
      *iv_return = ZMQ_RECOVERY_IVL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "ZMQ_PLAIN_SERVER", 16)) {
    /*                    ^                 */
#ifdef ZMQ_PLAIN_SERVER
      *iv_return = ZMQ_PLAIN_SERVER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'P':
    if (memEQ(name, "ZMQ_XPUB_VERBOSE", 16)) {
    /*                    ^                 */
#ifdef ZMQ_XPUB_VERBOSE
      *iv_return = ZMQ_XPUB_VERBOSE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "ZMQ_PROBE_ROUTER", 16)) {
    /*                    ^                 */
#ifdef ZMQ_PROBE_ROUTER
      *iv_return = ZMQ_PROBE_ROUTER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'U':
    if (memEQ(name, "ZMQ_CURVE_SERVER", 16)) {
    /*                    ^                 */
#ifdef ZMQ_CURVE_SERVER
      *iv_return = ZMQ_CURVE_SERVER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_17 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_GSSAPI_SERVER ZMQ_HANDSHAKE_IVL ZMQ_HEARTBEAT_IVL ZMQ_HEARTBEAT_TTL
     ZMQ_LAST_ENDPOINT ZMQ_RECONNECT_IVL ZMQ_REQ_CORRELATE ZMQ_ROUTER_NOTIFY
     ZMQ_STREAM_NOTIFY ZMQ_TCP_KEEPALIVE ZMQ_XPUB_VERBOSER */
  /* Offset 9 gives the best switch position.  */
  switch (name[9]) {
  case 'B':
    if (memEQ(name, "ZMQ_HEARTBEAT_IVL", 17)) {
    /*                        ^              */
#ifdef ZMQ_HEARTBEAT_IVL
      *iv_return = ZMQ_HEARTBEAT_IVL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "ZMQ_HEARTBEAT_TTL", 17)) {
    /*                        ^              */
#ifdef ZMQ_HEARTBEAT_TTL
      *iv_return = ZMQ_HEARTBEAT_TTL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "ZMQ_LAST_ENDPOINT", 17)) {
    /*                        ^              */
#ifdef ZMQ_LAST_ENDPOINT
      *iv_return = ZMQ_LAST_ENDPOINT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "ZMQ_TCP_KEEPALIVE", 17)) {
    /*                        ^              */
#ifdef ZMQ_TCP_KEEPALIVE
      *iv_return = ZMQ_TCP_KEEPALIVE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'H':
    if (memEQ(name, "ZMQ_HANDSHAKE_IVL", 17)) {
    /*                        ^              */
#ifdef ZMQ_HANDSHAKE_IVL
      *iv_return = ZMQ_HANDSHAKE_IVL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "ZMQ_GSSAPI_SERVER", 17)) {
    /*                        ^              */
#ifdef ZMQ_GSSAPI_SERVER
      *iv_return = ZMQ_GSSAPI_SERVER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'M':
    if (memEQ(name, "ZMQ_STREAM_NOTIFY", 17)) {
    /*                        ^              */
#ifdef ZMQ_STREAM_NOTIFY
      *iv_return = ZMQ_STREAM_NOTIFY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ZMQ_RECONNECT_IVL", 17)) {
    /*                        ^              */
#ifdef ZMQ_RECONNECT_IVL
      *iv_return = ZMQ_RECONNECT_IVL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ZMQ_REQ_CORRELATE", 17)) {
    /*                        ^              */
#ifdef ZMQ_REQ_CORRELATE
      *iv_return = ZMQ_REQ_CORRELATE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "ZMQ_ROUTER_NOTIFY", 17)) {
    /*                        ^              */
#ifdef ZMQ_ROUTER_NOTIFY
      *iv_return = ZMQ_ROUTER_NOTIFY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'V':
    if (memEQ(name, "ZMQ_XPUB_VERBOSER", 17)) {
    /*                        ^              */
#ifdef ZMQ_XPUB_VERBOSER
      *iv_return = ZMQ_XPUB_VERBOSER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_18 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_MULTICAST_HOPS ZMQ_PLAIN_PASSWORD ZMQ_PLAIN_USERNAME */
  /* Offset 16 gives the best switch position.  */
  switch (name[16]) {
  case 'M':
    if (memEQ(name, "ZMQ_PLAIN_USERNAME", 18)) {
    /*                               ^        */
#ifdef ZMQ_PLAIN_USERNAME
      *iv_return = ZMQ_PLAIN_USERNAME;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'P':
    if (memEQ(name, "ZMQ_MULTICAST_HOPS", 18)) {
    /*                               ^        */
#ifdef ZMQ_MULTICAST_HOPS
      *iv_return = ZMQ_MULTICAST_HOPS;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "ZMQ_PLAIN_PASSWORD", 18)) {
    /*                               ^        */
#ifdef ZMQ_PLAIN_PASSWORD
      *iv_return = ZMQ_PLAIN_PASSWORD;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_19 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_CONNECT_TIMEOUT ZMQ_CURVE_PUBLICKEY ZMQ_CURVE_SECRETKEY
     ZMQ_CURVE_SERVERKEY ZMQ_INVERT_MATCHING ZMQ_ROUTER_HANDOVER */
  /* Offset 13 gives the best switch position.  */
  switch (name[13]) {
  case 'I':
    if (memEQ(name, "ZMQ_CONNECT_TIMEOUT", 19)) {
    /*                            ^            */
#ifdef ZMQ_CONNECT_TIMEOUT
      *iv_return = ZMQ_CONNECT_TIMEOUT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "ZMQ_CURVE_PUBLICKEY", 19)) {
    /*                            ^            */
#ifdef ZMQ_CURVE_PUBLICKEY
      *iv_return = ZMQ_CURVE_PUBLICKEY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ZMQ_ROUTER_HANDOVER", 19)) {
    /*                            ^            */
#ifdef ZMQ_ROUTER_HANDOVER
      *iv_return = ZMQ_ROUTER_HANDOVER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "ZMQ_CURVE_SECRETKEY", 19)) {
    /*                            ^            */
#ifdef ZMQ_CURVE_SECRETKEY
      *iv_return = ZMQ_CURVE_SECRETKEY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (memEQ(name, "ZMQ_INVERT_MATCHING", 19)) {
    /*                            ^            */
#ifdef ZMQ_INVERT_MATCHING
      *iv_return = ZMQ_INVERT_MATCHING;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'V':
    if (memEQ(name, "ZMQ_CURVE_SERVERKEY", 19)) {
    /*                            ^            */
#ifdef ZMQ_CURVE_SERVERKEY
      *iv_return = ZMQ_CURVE_SERVERKEY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_20 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_GSSAPI_PLAINTEXT ZMQ_GSSAPI_PRINCIPAL ZMQ_ROUTER_MANDATORY
     ZMQ_VMCI_BUFFER_SIZE ZMQ_XPUB_WELCOME_MSG */
  /* Offset 17 gives the best switch position.  */
  switch (name[17]) {
  case 'E':
    if (memEQ(name, "ZMQ_GSSAPI_PLAINTEXT", 20)) {
    /*                                ^         */
#ifdef ZMQ_GSSAPI_PLAINTEXT
      *iv_return = ZMQ_GSSAPI_PLAINTEXT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "ZMQ_VMCI_BUFFER_SIZE", 20)) {
    /*                                ^         */
#ifdef ZMQ_VMCI_BUFFER_SIZE
      *iv_return = ZMQ_VMCI_BUFFER_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'M':
    if (memEQ(name, "ZMQ_XPUB_WELCOME_MSG", 20)) {
    /*                                ^         */
#ifdef ZMQ_XPUB_WELCOME_MSG
      *iv_return = ZMQ_XPUB_WELCOME_MSG;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ZMQ_ROUTER_MANDATORY", 20)) {
    /*                                ^         */
#ifdef ZMQ_ROUTER_MANDATORY
      *iv_return = ZMQ_ROUTER_MANDATORY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'P':
    if (memEQ(name, "ZMQ_GSSAPI_PRINCIPAL", 20)) {
    /*                                ^         */
#ifdef ZMQ_GSSAPI_PRINCIPAL
      *iv_return = ZMQ_GSSAPI_PRINCIPAL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_21 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_HEARTBEAT_TIMEOUT ZMQ_MULTICAST_MAXTPDU ZMQ_RECONNECT_IVL_MAX
     ZMQ_TCP_KEEPALIVE_CNT */
  /* Offset 8 gives the best switch position.  */
  switch (name[8]) {
  case 'I':
    if (memEQ(name, "ZMQ_MULTICAST_MAXTPDU", 21)) {
    /*                       ^                   */
#ifdef ZMQ_MULTICAST_MAXTPDU
      *iv_return = ZMQ_MULTICAST_MAXTPDU;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'K':
    if (memEQ(name, "ZMQ_TCP_KEEPALIVE_CNT", 21)) {
    /*                       ^                   */
#ifdef ZMQ_TCP_KEEPALIVE_CNT
      *iv_return = ZMQ_TCP_KEEPALIVE_CNT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ZMQ_RECONNECT_IVL_MAX", 21)) {
    /*                       ^                   */
#ifdef ZMQ_RECONNECT_IVL_MAX
      *iv_return = ZMQ_RECONNECT_IVL_MAX;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (memEQ(name, "ZMQ_HEARTBEAT_TIMEOUT", 21)) {
    /*                       ^                   */
#ifdef ZMQ_HEARTBEAT_TIMEOUT
      *iv_return = ZMQ_HEARTBEAT_TIMEOUT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option_24 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ZMQ_VMCI_BUFFER_MAX_SIZE ZMQ_VMCI_BUFFER_MIN_SIZE ZMQ_VMCI_CONNECT_TIMEOUT
     */
  /* Offset 18 gives the best switch position.  */
  switch (name[18]) {
  case 'I':
    if (memEQ(name, "ZMQ_VMCI_CONNECT_TIMEOUT", 24)) {
    /*                                 ^            */
#ifdef ZMQ_VMCI_CONNECT_TIMEOUT
      *iv_return = ZMQ_VMCI_CONNECT_TIMEOUT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ZMQ_VMCI_BUFFER_MIN_SIZE", 24)) {
    /*                                 ^            */
#ifdef ZMQ_VMCI_BUFFER_MIN_SIZE
      *iv_return = ZMQ_VMCI_BUFFER_MIN_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'X':
    if (memEQ(name, "ZMQ_VMCI_BUFFER_MAX_SIZE", 24)) {
    /*                                 ^            */
#ifdef ZMQ_VMCI_BUFFER_MAX_SIZE
      *iv_return = ZMQ_VMCI_BUFFER_MAX_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_socket_option (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(ZMQ_AFFINITY ZMQ_BACKLOG ZMQ_BLOCKY ZMQ_CONFLATE
	       ZMQ_CONNECT_RID ZMQ_CONNECT_TIMEOUT ZMQ_CURVE_PUBLICKEY
	       ZMQ_CURVE_SECRETKEY ZMQ_CURVE_SERVER ZMQ_CURVE_SERVERKEY
	       ZMQ_EVENTS ZMQ_FD ZMQ_GSSAPI_PLAINTEXT ZMQ_GSSAPI_PRINCIPAL
	       ZMQ_GSSAPI_SERVER ZMQ_GSSAPI_SERVICE_PRINCIPAL ZMQ_HANDSHAKE_IVL
	       ZMQ_HEARTBEAT_IVL ZMQ_HEARTBEAT_TIMEOUT ZMQ_HEARTBEAT_TTL
	       ZMQ_IDENTITY ZMQ_IMMEDIATE ZMQ_INVERT_MATCHING ZMQ_IPV6
	       ZMQ_LAST_ENDPOINT ZMQ_LINGER ZMQ_MAXMSGSIZE ZMQ_MECHANISM
	       ZMQ_MULTICAST_HOPS ZMQ_MULTICAST_MAXTPDU ZMQ_PLAIN_PASSWORD
	       ZMQ_PLAIN_SERVER ZMQ_PLAIN_USERNAME ZMQ_PROBE_ROUTER ZMQ_RATE
	       ZMQ_RCVBUF ZMQ_RCVHWM ZMQ_RCVMORE ZMQ_RCVTIMEO ZMQ_RECONNECT_IVL
	       ZMQ_RECONNECT_IVL_MAX ZMQ_RECOVERY_IVL ZMQ_REQ_CORRELATE
	       ZMQ_REQ_RELAXED ZMQ_ROUTER_HANDOVER ZMQ_ROUTER_MANDATORY
	       ZMQ_ROUTER_NOTIFY ZMQ_ROUTER_RAW ZMQ_ROUTING_ID ZMQ_SNDBUF
	       ZMQ_SNDHWM ZMQ_SNDTIMEO ZMQ_SOCKS_PROXY ZMQ_STREAM_NOTIFY
	       ZMQ_SUBSCRIBE ZMQ_TCP_KEEPALIVE ZMQ_TCP_KEEPALIVE_CNT
	       ZMQ_TCP_KEEPALIVE_IDLE ZMQ_TCP_KEEPALIVE_INTVL ZMQ_TCP_MAXRT
	       ZMQ_THREAD_SAFE ZMQ_TOS ZMQ_TYPE ZMQ_UNSUBSCRIBE ZMQ_USE_FD
	       ZMQ_VMCI_BUFFER_MAX_SIZE ZMQ_VMCI_BUFFER_MIN_SIZE
	       ZMQ_VMCI_BUFFER_SIZE ZMQ_VMCI_CONNECT_TIMEOUT ZMQ_XPUB_MANUAL
	       ZMQ_XPUB_NODROP ZMQ_XPUB_VERBOSE ZMQ_XPUB_VERBOSER
	       ZMQ_XPUB_WELCOME_MSG ZMQ_ZAP_DOMAIN));

print constant_types(), "\n"; # macro defs
foreach (C_constant ("ZMQ::Raw::Socket", '_socket_option', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("ZMQ::Raw::Socket", $types);
__END__
   */

  switch (len) {
  case 6:
    if (memEQ(name, "ZMQ_FD", 6)) {
#ifdef ZMQ_FD
      *iv_return = ZMQ_FD;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 7:
    if (memEQ(name, "ZMQ_TOS", 7)) {
#ifdef ZMQ_TOS
      *iv_return = ZMQ_TOS;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 8:
    return _socket_option_8 (aTHX_ name, iv_return);
    break;
  case 10:
    return _socket_option_10 (aTHX_ name, iv_return);
    break;
  case 11:
    /* Names all of length 11.  */
    /* ZMQ_BACKLOG ZMQ_RCVMORE */
    /* Offset 10 gives the best switch position.  */
    switch (name[10]) {
    case 'E':
      if (memEQ(name, "ZMQ_RCVMOR", 10)) {
      /*                         E      */
#ifdef ZMQ_RCVMORE
        *iv_return = ZMQ_RCVMORE;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'G':
      if (memEQ(name, "ZMQ_BACKLO", 10)) {
      /*                         G      */
#ifdef ZMQ_BACKLOG
        *iv_return = ZMQ_BACKLOG;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 12:
    return _socket_option_12 (aTHX_ name, iv_return);
    break;
  case 13:
    return _socket_option_13 (aTHX_ name, iv_return);
    break;
  case 14:
    return _socket_option_14 (aTHX_ name, iv_return);
    break;
  case 15:
    return _socket_option_15 (aTHX_ name, iv_return);
    break;
  case 16:
    return _socket_option_16 (aTHX_ name, iv_return);
    break;
  case 17:
    return _socket_option_17 (aTHX_ name, iv_return);
    break;
  case 18:
    return _socket_option_18 (aTHX_ name, iv_return);
    break;
  case 19:
    return _socket_option_19 (aTHX_ name, iv_return);
    break;
  case 20:
    return _socket_option_20 (aTHX_ name, iv_return);
    break;
  case 21:
    return _socket_option_21 (aTHX_ name, iv_return);
    break;
  case 22:
    if (memEQ(name, "ZMQ_TCP_KEEPALIVE_IDLE", 22)) {
#ifdef ZMQ_TCP_KEEPALIVE_IDLE
      *iv_return = ZMQ_TCP_KEEPALIVE_IDLE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 23:
    if (memEQ(name, "ZMQ_TCP_KEEPALIVE_INTVL", 23)) {
#ifdef ZMQ_TCP_KEEPALIVE_INTVL
      *iv_return = ZMQ_TCP_KEEPALIVE_INTVL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 24:
    return _socket_option_24 (aTHX_ name, iv_return);
    break;
  case 28:
    if (memEQ(name, "ZMQ_GSSAPI_SERVICE_PRINCIPAL", 28)) {
#ifdef ZMQ_GSSAPI_SERVICE_PRINCIPAL
      *iv_return = ZMQ_GSSAPI_SERVICE_PRINCIPAL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

